/*
 * BL_TB_ActiveBtn.java
 * Created on 2. Dezember 2007, 18:44
 * BorderLiner Toolbar Apply To Button
 */

package name.dhiller.jBorderLiner;

import com.sun.star.beans.NamedValue;
import com.sun.star.uno.XComponentContext;
import name.dhiller.ooo.OOoRegistry.OOoRegistry;
import javax.swing.JOptionPane;             // for Messagebox TEST only

/**
 * @author dhiller
 * @version 110223
 * @since LibreOffice 3.3.x (Dropdownbox) --> not yet implemented
 */
class BL_TB_ApplyToBtn extends BL_ToolbarItem {

    private static String[] saApplyToList;
    private static String sApplyTo;
    
    /** Creates a new instance of BL_TB_ActiveBtn 
     */
    BL_TB_ApplyToBtn() {
        super();
    }
    
    /**
     * Initialize the apply to button
     * @param xContext for Registry reading
     * @param xFrame
     * @param xControl xStatusListener
     * @param sPackageName name of package
     * @param aURL
     */
    void Init(XComponentContext xContext, com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl, String sPackageName,
              com.sun.star.util.URL aURL) {
        super.Init (xFrame, xControl, aURL, null);
        
        OOoRegistry tempBLRegistry = new OOoRegistry(xContext);
        saApplyToList = new String[2];
        saApplyToList[0] = new String(tempBLRegistry.getString(sPackageName, 
                "Settings", "Cell") );
        saApplyToList[1] = new String(tempBLRegistry.getString(sPackageName, 
                "Settings", "Table") );
         
        NamedValue asTemplate = new NamedValue();
        NamedValue[] loadArgs = new NamedValue[1];

        // create a sequence of strings for the dropdown menu
        asTemplate.Name = new String("List");
        asTemplate.Value = saApplyToList;
        // assign NamedValue struct to first element in our array of references to NamedValue structs
        loadArgs[0] = asTemplate;
        SendCommandTo(xControl, new String("SetList"), loadArgs);
                                
        // set position
        asTemplate.Name = "Entry"; // Dropdownbox: Entry, was Pos
        asTemplate.Value = 1; // Dropdownbox: 1, was 0
        loadArgs[0] = asTemplate;
        sApplyTo = saApplyToList[0];
        SendCommandTo(xControl, new String("SelectEntry"), loadArgs); // Dropdownbox: SelectEntry, was CheckItemPos
    }
    
    /**
     * @param aURL
     * @param aArguments Name[0]="KeyModifier" [1]="Text"
     */
    void dispatch(com.sun.star.util.URL aURL,
                  com.sun.star.beans.PropertyValue[] aArguments ) {
       int i;
       //String sValue = new String();
       for (i=0; i < aArguments.length; i++) {
           if (aArguments[i].Name.equals("Text")) {
                sApplyTo = aArguments[i].Value.toString();
                javax.swing.JOptionPane.showMessageDialog(null, "value of Text:"+sApplyTo+":"); // Test
                NamedValue asTemplate = new NamedValue();
                NamedValue[] loadArgs = new NamedValue[1];
                asTemplate.Name = "Entry"; // Dropdownbox: Entry, was Pos
                asTemplate.Value = GetApplyTo();
                loadArgs[0] = asTemplate;
                sendCommandToAll("SelectEntry", loadArgs); // Dropdownbox: SelectEntry, was CheckItemPos
                break;
           }
       }
    }
    
    /**
     * Gets the object (cell or table) to apply the border to
     * @return 0: apply to Cell, 1: apply to Table
     */
    short GetApplyTo() {
        if (sApplyTo.equals(saApplyToList[0]))
            { return 0; }
        else 
            { return 1; }
    }
}