/*
 * BL_TB_ActiveBtn.java
 * Created on 2. Dezember 2007, 18:44
 * BorderLiner Toolbar Active Button
 */

package name.dhiller.jBorderLiner;

import com.sun.star.beans.NamedValue;
import com.sun.star.frame.*;
import com.sun.star.uno.XComponentContext;

import name.dhiller.ooo.ColorChooser.ColorChooser;
import java.awt.Color;

//import javax.swing.colorchooser.*;
import java.awt.BorderLayout;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.UIManager;
import javax.swing.LookAndFeel;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * @author Dietmar Hiller (dhiller)
 * @version 080507
 */
class BL_TB_SelectColorBtn extends BL_ToolbarItem {
    Color currentColor;
    static String m_sDlgDir;
    static String m_sDlgName;
    static String m_sDlgHue;
    static XComponentContext m_xContext;
    static boolean active;
    
    /** Creates a new instance of BL_TB_ActiveBtn */
    BL_TB_SelectColorBtn() {
        super();
        currentColor = java.awt.Color.BLACK;
    }

    /** Init DlgButton
     * @param xFrame - Frame of control
     * @param xControl - StatusListener
     * @param aURL - URL to Toolbarbutton
     * @param sDlgDir - URL of directory with dialog
     * @param sDlgName - Name of dialog
     * @param sDlgHue - URL to image of hue
     */
    void Init(com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl,
              com.sun.star.util.URL aURL, 
              String sDlgDir, String sDlgName, String sDlgHue, 
              XComponentContext xContext) {
        super.Init (xFrame, xControl, aURL, null);
         
        m_sDlgDir = sDlgDir;
        m_sDlgName = sDlgName;
        m_sDlgHue = sDlgHue;
        m_xContext = xContext;
        FeatureStateEvent aState = new FeatureStateEvent();
        aState.FeatureURL = aURL;
        aState.IsEnabled  = true;
        active  = false;
        aState.State      = active;
        xControl.statusChanged(aState);
    }

    /** Exchange data with toolbar item
     * @param aURL
     * @param aArguments (.Name="SetColor", .Value=Color), (.Name=else, call dialog)
     */
    void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments ) {
       int i;
       ColorChooser oColorDialog;
       for (i=0; i < aArguments.length; i++) {
           if (aArguments[i].Name.equals("SetColor")) {
               currentColor = new Color((Integer) aArguments[i].Value);
           }
           else { 
               oColorDialog = new ColorChooser(m_xContext);
               Color newColor = oColorDialog.executeDialog(m_sDlgDir, m_sDlgName, m_sDlgHue, 
                       currentColor);
               if (newColor != null) currentColor = newColor;
           }
       }
    }
        
    /** loads the color
     * @param inColor - color loaded
     */
    void setColor(int inColor) {
        currentColor = new Color(inColor);
    }
    
    int GetColor() {
        return currentColor.getBlue()+currentColor.getGreen()*256+currentColor.getRed()*256*256;// getRGB());
    }
}