/*
 * BL_TB_ActiveBtn.java
 * Created on 2. Dezember 2007, 18:44
 * BorderLiner Toolbar Active Button
 */

package name.dhiller.jBorderLiner;

import com.sun.star.beans.NamedValue;
//import com.sun.star.frame.*;
import com.sun.star.table.BorderLine;
import java.lang.Math;

/**
 * @author Dhiller
 * @version 080116
 */
class BL_TB_SelectLSBtn extends BL_ToolbarItem {
    private static com.sun.star.frame.XFrame mxFrame;
    static int icurrentLinestyle;
                                // OuterLineWidth, InnerLineWidth, LineDistance
    private static final short[][] LSList = { {0,0,0}, {35,0,0}, {2,0,0}, {18,0,0},
        {88,0,0}, {141,0,0}, {176,0,0}, {2,2,35}, {2,2,88}, {35,35,35}, 
        {88,88,88}, {35,2,88}, {88,2,88}, {141,2,88}, {88,35,88}, {35,88,35}, 
        {141,88,88}, {88,141,88} };
    private static final int iInitialValue = 1;
    private static final int iLowerLimit = 0;
    private static final int iUpperLimit = 17;
    private static final int iStep = 1;
    
    /** Creates a new instance of BL_TB_ActiveBtn */
    BL_TB_SelectLSBtn() {
        super();
        icurrentLinestyle = iInitialValue;
    }
    
    /** init - Initialize Toolbarbutton to select the linestyle
     * @param com.sun.star.frame.XStatusListener xControl
     * @param com.sun.star.util.URL my URL
     *{@inheritDoc}
     */
    void Init(com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl,
              com.sun.star.util.URL aURL) {

       super.Init (xFrame, xControl, aURL, null);

       NamedValue[] loadArgs = new NamedValue[4];

       loadArgs[0]=new NamedValue();
       loadArgs[0].Name = "Step";
       loadArgs[0].Value = iStep;
                
       loadArgs[1]=new NamedValue();
       loadArgs[1].Name = "LowerLimit";
       loadArgs[1].Value = iLowerLimit;

       loadArgs[2]=new NamedValue();
       loadArgs[2].Name = "UpperLimit";
       loadArgs[2].Value = iUpperLimit;
 
       loadArgs[3]=new NamedValue();
       loadArgs[3].Name = "Value";
       loadArgs[3].Value = icurrentLinestyle;

       // new toolbar, need only to inform this of the value the others already have
       SendCommandTo(xControl, new String("SetValues"), loadArgs);
           
                                                    // update linestylepreview
       jBorderLiner.TB_LSPreview.setLinestyle(icurrentLinestyle);
    }
    
    /** dispatch - got a message, act
     * @param com.sun.star.util.URL my URL
     * @param com.sun.star.beans.PropertyValue[] Arguments, Name = "KeyModifier", "Value"
     */
    void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments) {
       int i;
       String sValue = new String();
       for (i=0; i < aArguments.length; i++) {
           if (aArguments[i].Name.equals("Value")) {
               sValue = aArguments[i].Value.toString();
               break;
           }
       }
       
       if (!sValue.equals(null)) {
           setLineNumber(Integer.parseInt(sValue));
       }
    }
    
    /**
     */
    com.sun.star.table.BorderLine GetLineStyle() {
        com.sun.star.table.BorderLine BL = new BorderLine();
        BL.OuterLineWidth = LSList[icurrentLinestyle][0];
        BL.InnerLineWidth = LSList[icurrentLinestyle][1];
        BL.LineDistance   = LSList[icurrentLinestyle][2];
        BL.Color          = 0;
        return BL;
    }
    
    /** set line style
     * need to write value to toolbar again in case user entered data manually
     * and also to inform all toolbars of the change
     * 
     * @param iLS - Linestyle
     */
    void setLineNumber(int iLS) {
        icurrentLinestyle = Math.max(iLowerLimit, iLS);
        icurrentLinestyle = Math.min(iUpperLimit, icurrentLinestyle);
        
        NamedValue[] loadArgs = new NamedValue[1];
        loadArgs[0]=new NamedValue();
        loadArgs[0].Name = "Value";
        loadArgs[0].Value = icurrentLinestyle;

                                // inform all toolbars about new linestyle  
        sendCommandToAll("SetValues", loadArgs);

        //## also to all toolbars for this one, NB also used in this.Init
        jBorderLiner.TB_LSPreview.setLinestyle(icurrentLinestyle);
    }
    
    /**
     */
    short[][] GetLSList() {
        return LSList;
    }
    
}